/*
This is an unsupported product. It was developed as part of a study at Ostfold
Regional College, Norway in the spring of 1992.

You use this software at your own risk. Neither the authors nor the Ostfold
Regional College nor any other person or organization except yourself is
responsible for any damage or loss of data derived from the use of this
software. You may distribute this software freely as long as it is in its
original form and all of its files are included. If you make any changes to any
part of this software or the files distributed with it, please state so and do
NOT distribute it under its original name.
*/

/* 
This module is the main module of the agentd program.
*/

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>
#include <sys/wait.h>
#include "nntp_tcp.h"
#include "server.h"

/*
-----------------------------------------------------------------------------
Function name: main()
-----------------------------------------------------------------------------
Parameters:	int argc		Number of arguments.
		char *argv		List of arguments.
Return value:	none
Called by:	none
Calls:		tcp_connect_listen(), do_server()
Description:	This function runs in an infinitive loop listening to a port
		and starting up the server when connection has been
		established.
-----------------------------------------------------------------------------
*/

main( argc, argv)
int argc;
char *argv[];
{
	int s, t, f, i, port;
	struct sockaddr_in i_sa;
	char command[80];

        myname = argv[0];

        if(argc != 2) {
                fprintf(stderr, "Usage: %s port\n", myname);
                exit(1);
        }
	port = atoi(argv[1]);
	s = tcp_connect_listen(port);

	while(1) {
		i = sizeof(i_sa);
		if(( t = accept( s, &i_sa, &i)) < 0) {
			perror("accept");
			exit(1);
		}

		if((f = fork()) < 0 ) {
			perror("fork");
			exit(1);
		}

		if( f == 0 )
			do_server(t);
		else
			close(t);

		while(wait3(NULL, WNOHANG, NULL) != 0) {
		}
	}
}
